Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Help/Main_License.txt
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Help/Main_License.txt	(revision 339)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Help/Main_License.txt	(revision 345)
@@ -1,1 +1,1 @@
-XTIDE Universal BIOS and XTIDECFG Configuration program are Copyright 2009-2012 by Tomi Tilli. Released under GNU GPL v2. This software comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions. See the LICENSE.TXT file that was included with this distribution, visit http://www.gnu.org/licenses/ gpl-2.0.html, or visit http://code.coogle.com/p/ xtideuniversalbios.
+XTIDE Universal BIOS and XTIDECFG Configuration program are Copyright 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team. Released under GNU GPL v2. This software comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions. See the LICENSE.TXT file that was included with this distribution, visit http://www.gnu.org/licenses/ gpl-2.0.html, or visit http://code.coogle.com/p/ xtideuniversalbios.
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/MenuCfg.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/MenuCfg.inc	(revision 339)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/MenuCfg.inc	(revision 345)
@@ -1,7 +1,3 @@
-; File name		:	MenuCfg.inc
 ; Project name	:	XTIDE Universal BIOS Configurator v2
-; Created date	:	5.10.2010
-; Last update	:	18.10.2010
-; Author		:	Tomi Tilli
 ; Description	:	Menu configuration.
 %ifndef MENUCFG_INC
@@ -9,5 +5,5 @@
 
 TITLE_LINES_IN_MENU			EQU		3
-INFO_LINES_IN_MENU			EQU		4
+INFO_LINES_IN_MENU			EQU		6
 MENU_WIDTH					EQU		40
 MAX_VALUE_STRING_LENGTH		EQU		12
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm	(revision 339)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/MasterSlaveMenu.asm	(revision 345)
@@ -345,6 +345,15 @@
 ALIGN JUMP_ALIGN
 ValueReaderForUserLbaValue:
-	mov		ax, [es:di+2]		; SHR 16
-	eSHIFT_IM ax, 4, shr		; SHR 16 + 4 = 20
+	push	dx
+
+	mov		ax, [es:di]
+	mov		dx, [es:di+2]		; DX:AX now holds user defined LBA28 limit
+	add		ax, BYTE 1			; Increment by one
+	adc		dx, BYTE 0
+
+	xchg	ax, dx				; SHR 16
+	eSHIFT_IM ax, 4, shr		; SHR 4 => AX = DX:AX / (1024*1024)
+
+	pop		dx
 	ret
 
@@ -363,6 +372,14 @@
 ALIGN JUMP_ALIGN
 ValueWriterForUserLbaValue:
+	push	dx
+
+	xor		dx, dx
 	eSHIFT_IM ax, 4, shl
-	mov		[es:di+2], ax
-	xor		ax, ax		; Store zero to [es:di]
-	ret
+	xchg	dx, ax			; DX:AX now holds AX * 1024 * 1024
+
+	sub		ax, BYTE 1		; Decrement DX:AX by one
+	sbb		dx, BYTE 0		; (necessary since maximum LBA28 sector count is 0FFF FFFFh)
+
+	mov		[es:di+2], dx	; Store DX by ourselves
+	pop		dx
+	ret						; AX will be stored by our menu system
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 339)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 345)
@@ -74,5 +74,5 @@
 g_szNfoMainConfigure:	db	"Configure XTIDE Universal BIOS settings.",NULL
 g_szNfoMainFlash:		db	"Flash loaded BIOS image to EEPROM.",NULL
-g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG Copyright 2009-2012 by Tomi Tilli. Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY. Details...",NULL
+g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team. Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY. Details...",NULL
 g_szNfoMainHomePage:	db	"Visit http://code.google.com/p/ xtideuniversalbios (home page) and http://vintage-computer.com/ vcforum (support)",NULL
 