Index: trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 369)
@@ -14,5 +14,5 @@
 ;		AX, DX, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 CharOutLineSplitter_PrepareForPrintingTextLines:
 	; Get first text line column offset to DX
@@ -41,5 +41,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 CharOutLineSplitter_GetFirstBorderLineColumnOffsetToAX:
 	call	MenuLocation_GetTitleBordersTopLeftCoordinatesToAX
@@ -60,5 +60,5 @@
 ;		DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 CharOutLineSplitter_IsCursorAtTheEndOfTextLine:
 	push	ax
@@ -86,5 +86,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 CharOutLineSplitter_MovePartialWordToNewTextLine:
 	push	si
@@ -106,5 +106,5 @@
 	mov		cx, di
 	mov		si, di
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ScanNextCharacter:		; Space will always be found since one comes after border
 	dec		si
Index: trunk/Assembly_Library/Src/Menu/Menu.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Menu.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/Menu.asm	(revision 369)
@@ -17,5 +17,5 @@
 ;		AX (unless used as a return register), DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 Menu_FunctionFromDI:
 	push	si
Index: trunk/Assembly_Library/Src/Menu/MenuAttributes.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 369)
@@ -28,5 +28,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuAttribute_SetToDisplayContextFromTypeInSI:
 	call	MenuAttribute_GetToAXfromTypeInSI
@@ -44,5 +44,5 @@
 ;		SI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuAttribute_GetToAXfromTypeInSI:
 	push	ds
@@ -59,10 +59,10 @@
 	jmp		SHORT .LoadAttributeAndReturn
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .LoadMonoAttribute:
 	add		si, .rgcMonochromeAttributes
 	jmp		SHORT .LoadAttributeAndReturn
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .LoadColorAttribute:
 	add		si, .rgcColorAttributes
Index: trunk/Assembly_Library/Src/Menu/MenuBorders.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 369)
@@ -22,5 +22,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_RefreshAll:
 %ifndef USE_186
@@ -52,5 +52,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_RedrawBottomBorderLine:
 	call	MenuBorders_AdjustDisplayContextForDrawingBorders
@@ -71,5 +71,5 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_RefreshItemBorders:
 	call	MenuBorders_AdjustDisplayContextForDrawingBorders
@@ -91,5 +91,5 @@
 ;		AX, BX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_AdjustDisplayContextForDrawingBorders:
 	mov		bl, ATTRIBUTES_ARE_USED
@@ -116,5 +116,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_GetNumberOfMiddleCharactersToDX:
 	eMOVZX	dx, [bp+MENUINIT.bWidth]
@@ -133,5 +133,5 @@
 ;		AX, BX, CX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 RefreshTitleBorders:
 	call	DrawTopBorderLine
@@ -149,5 +149,5 @@
 ;		AX, BX, CX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 RefreshInformationBorders:
 	call	DrawSeparationBorderLine
@@ -165,5 +165,5 @@
 ;		AX, BX, CX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 RefreshItemBorders:
 	call	DrawSeparationBorderLine
@@ -184,5 +184,5 @@
 DrawTextBorderLinesByCXtimes:
 	jcxz	.NoBorderLinesToDraw
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .DrawBordersWithFunctionInBX:
 	call	DrawTextBorderLine
@@ -207,5 +207,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawTopBorderLine:
 	mov		si, g_rgbTopBorderCharacters
@@ -213,10 +213,10 @@
 	jmp		SHORT PrintNewlineToEndBorderLine
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawSeparationBorderLine:
 	mov		si, g_rgbSeparationBorderCharacters
 	jmp		SHORT PrintBorderCharactersFromCSSIandShadowCharacter
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawBottomBorderLine:
 	mov		si, g_rgbBottomBorderCharacters
@@ -231,5 +231,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawBottomShadowLine:
 	CALL_DISPLAY_LIBRARY GetSoftwareCoordinatesToAX
@@ -243,5 +243,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawTextBorderLine:
 	mov		si, g_rgbTextBorderCharacters
@@ -259,5 +259,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrintBorderCharactersFromCSSIandShadowCharacter:
 	call	PrintBorderCharactersFromCSSI
@@ -277,5 +277,5 @@
 ;		AX, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrintNewlineToEndBorderLine:
 	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
@@ -293,5 +293,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrintShadowCharactersByDXtimes:
 	CALL_DISPLAY_LIBRARY PushDisplayContext
@@ -323,5 +323,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrintBorderCharactersFromCSSI:
 	cs lodsb		; Load from [cs:si+BORDER_CHARS.cLeft] to AL
@@ -346,10 +346,10 @@
 ;		AX, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_PrintSingleBorderCharacterFromAL:
 	CALL_DISPLAY_LIBRARY PrintCharacterFromAL
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuBorders_PrintMultipleBorderCharactersFromAL:
 	push	cx
@@ -369,5 +369,5 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawTimeoutCounterString:
 	call	MenuTime_GetTimeoutSecondsLeftToAX
Index: trunk/Assembly_Library/Src/Menu/MenuCharOut.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuCharOut.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuCharOut.asm	(revision 369)
@@ -21,5 +21,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuCharOut_MenuTeletypeOutputWithAutomaticLineChange:
 	call	CharOutLineSplitter_IsCursorAtTheEndOfTextLine
@@ -30,5 +30,5 @@
 	; Fall to MenuCharOut_MenuTextTeletypeOutputWithAttribute
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuCharOut_MenuTeletypeOutput:
 	cmp		al, CR
@@ -51,5 +51,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuCharOut_PrintLFCRandAdjustOffsetForStartOfLine:
 	mov		al, LF
@@ -57,5 +57,5 @@
 	; Fall to PrintCRandAdjustOffsetForStartOfLine
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrintCRandAdjustOffsetForStartOfLine:
 	mov		al, CR
Index: trunk/Assembly_Library/Src/Menu/MenuEvent.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuEvent.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuEvent.asm	(revision 369)
@@ -16,5 +16,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_InitializeMenuinit:
 	push	ss
@@ -35,5 +35,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_ExitMenu:
 	mov		bl, MENUEVENT_ExitMenu
@@ -52,5 +52,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_IdleProcessing:
 	mov		bl, MENUEVENT_IdleProcessing
@@ -70,5 +70,5 @@
 ;		AX, CX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_RefreshTitle:
 	mov		bl, MENUEVENT_RefreshTitle
@@ -93,5 +93,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_RefreshItemFromCX:
 	mov		bl, MENUEVENT_RefreshItemFromCX
@@ -109,5 +109,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_HighlightItemFromCX:
 	mov		dx, cx
@@ -136,5 +136,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_KeyStrokeInAX:
 	mov		bl, MENUEVENT_KeyStrokeInAX
@@ -171,5 +171,5 @@
 ;		BX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuEvent_SendFromBX:
 	push	es
Index: trunk/Assembly_Library/Src/Menu/MenuInit.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 369)
@@ -15,5 +15,5 @@
 ;		All except segments
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_DisplayMenuWithHandlerInBXandUserDataInDXAX:
 	push	es
@@ -49,5 +49,5 @@
 ;		All, except SS:BP
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_EnterMenuWithHandlerInBXandUserDataInDXAX:
 	mov		[bp+MENU.fnEventHandler], bx
@@ -76,5 +76,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_RefreshMenuWindow:
 	call	MenuBorders_RefreshAll			; Draw borders
@@ -94,5 +94,5 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_CloseMenuIfExitEventAllows:
 	call	MenuEvent_ExitMenu
@@ -111,5 +111,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_CloseMenuWindow:
 	or		BYTE [bp+MENU.bFlags], FLG_MENU_EXIT
@@ -127,5 +127,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_HighlightItemFromAX:
 	sub		ax, [bp+MENUINIT.wHighlightedItem]
@@ -142,5 +142,5 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_GetHighlightedItemToAX:
 	mov		ax, [bp+MENUINIT.wHighlightedItem]
@@ -162,15 +162,15 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_SetTitleHeightFromAL:
 	mov		[bp+MENUINIT.bTitleLines], al
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_SetInformationHeightFromAL:
 	mov		[bp+MENUINIT.bInfoLines], al
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_SetTotalItemsFromAX:
 	mov		[bp+MENUINIT.wItems], ax
@@ -191,5 +191,5 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_SetUserDataFromDSSI:
 	mov		[bp+MENU.dwUserData], si
@@ -197,5 +197,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuInit_GetUserDataToDSSI:
 	lds		si, [bp+MENU.dwUserData]
Index: trunk/Assembly_Library/Src/Menu/MenuLocation.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 369)
@@ -16,5 +16,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_GetTextCoordinatesToAXforItemInAX:
 	sub		ax, [bp+MENU.wFirstVisibleItem]		; Item to line
@@ -42,5 +42,5 @@
 	jmp		SHORT AddItemBordersTopLeftCoordinatesToAX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_GetTitleTextTopLeftCoordinatesToAX:
 	mov		ax, (MENU_TEXT_ROW_OFFSET<<8) | MENU_TEXT_COLUMN_OFFSET
@@ -50,10 +50,10 @@
 	jmp		SHORT MenuLocation_AddTitleBordersTopLeftCoordinatesToAX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_GetInformationTextTopLeftCoordinatesToAX:
 	mov		ax, (MENU_TEXT_ROW_OFFSET<<8) | MENU_TEXT_COLUMN_OFFSET
 	jmp		SHORT AddInformationBordersTopLeftCoordinatesToAX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_GetBottomBordersTopLeftCoordinatesToAX:
 	xor		ax, ax
@@ -77,5 +77,5 @@
 	stc							; Compensate for Information top border
 	adc		ah, [bp+MENUINIT.bInfoLines]
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 AddInformationBordersTopLeftCoordinatesToAX:
 	push	cx
@@ -84,9 +84,9 @@
 	add		ah, cl
 	pop		cx
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 AddItemBordersTopLeftCoordinatesToAX:
 	stc							; Compensate for Title top border
 	adc		ah, [bp+MENUINIT.bTitleLines]
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_AddTitleBordersTopLeftCoordinatesToAX:
 	push	di
@@ -112,5 +112,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLocation_GetMaxTextLineLengthToAX:
 	eMOVZX	ax, [bp+MENUINIT.bWidth]
Index: trunk/Assembly_Library/Src/Menu/MenuLoop.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuLoop.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuLoop.asm	(revision 369)
@@ -14,5 +14,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLoop_Enter:
 	call	KeystrokeProcessing
@@ -36,5 +36,5 @@
 ;		All, except SS:BP
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 KeystrokeProcessing:
 	call	Keyboard_GetKeystrokeToAX
@@ -43,5 +43,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 TimeoutProcessing:
 	call	MenuTime_UpdateSelectionTimeout
@@ -62,5 +62,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 ProcessKeystrokeFromAX:
 	xchg	cx, ax
@@ -85,5 +85,5 @@
 ;		BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ProcessMenuSystemKeystrokeFromAX:
 	cmp		al, ESC
@@ -96,5 +96,5 @@
 	ret		; Return with CF cleared since keystroke not processed
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .LeaveMenuWithoutSelectingItem:
 	call	MenuEvent_ExitMenu
@@ -106,5 +106,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .SelectItem:
 	mov		cx, [bp+MENUINIT.wHighlightedItem]
@@ -128,5 +128,5 @@
 ;		BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuLoop_ProcessScrollingKeysFromAX:
 	xchg	ah, al
@@ -148,5 +148,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ChangeToPreviousPage:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
@@ -157,5 +157,5 @@
 	jge		SHORT .MoveHighlightedItemByAX	; No rotation for PgUp
 	; Fall to .SelectFirstItem
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .SelectFirstItem:
 	mov		ax, [bp+MENUINIT.wHighlightedItem]
@@ -163,5 +163,5 @@
 	jmp		SHORT .MoveHighlightedItemByAX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ChangeToNextPage:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
@@ -172,5 +172,5 @@
 	jb		SHORT .MoveHighlightedItemByAX	; No rotation for PgDn
 	; Fall to .SelectLastItem
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .SelectLastItem:
 	stc
@@ -179,5 +179,5 @@
 	jmp		SHORT .MoveHighlightedItemByAX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .DecrementSelectedItem:
 	mov		ax, -1
@@ -185,5 +185,5 @@
 .IncrementSelectedItem:
 	mov		al, 1	; AH is already 0
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .MoveHighlightedItemByAX:
 	call	MenuScrollbars_MoveHighlightedItemByAX
Index: trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm	(revision 369)
@@ -15,5 +15,5 @@
 ;		AX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_AreScrollbarsNeeded:
 	xchg	ax, cx
@@ -34,5 +34,5 @@
 ;		AH, CX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_GetScrollCharacterToALForLineInDI:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
@@ -45,10 +45,10 @@
 	call	.GetLastThumbLineToAX
 	cmp		ax, di				; After last thumb line?
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ReturnTrackCharacter:
 	mov		al, SCROLL_TRACK_CHARACTER
 	jb		SHORT .Return
 	mov		al, SCROLL_THUMB_CHARACTER
-ALIGN JUMP_ALIGN, ret
+ALIGN MENU_JUMP_ALIGN, ret
 .Return:
 	ret
@@ -64,5 +64,5 @@
 ;		CX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .GetLastThumbLineToAX:
 	call	MenuScrollbars_GetLastVisibleItemOnPageToAX
@@ -80,5 +80,5 @@
 ;		CX, DX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .CalculateFirstOrLastThumbLineToAX:
 	mul		cx
@@ -97,5 +97,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_MoveHighlightedItemByAX:
 	mov		cx, [bp+MENUINIT.wHighlightedItem]
@@ -120,5 +120,5 @@
 	jae		SHORT .ScrollPageForNewItemInCX
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .RotateNegativeItemInCX:
 	add		cx, dx
@@ -135,5 +135,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ScrollPageForNewItemInCX:
 	call	MenuScrollbars_IsItemInCXonVisiblePage
@@ -154,5 +154,5 @@
 	cwd		; This won't work if MaxFirstVisibleItem > 32767
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .DXisPositive:
 	cmp		ax, dx
@@ -160,10 +160,10 @@
 	xchg	dx, ax
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .AXisLessThanDX:
 	mov		[bp+MENU.wFirstVisibleItem], ax
 	call	MenuText_RefreshAllItems
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .HighlightNewItemOnCX:
 	jmp		MenuEvent_HighlightItemFromCX
@@ -181,5 +181,5 @@
 ;		AX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_IsItemInCXonVisiblePage:
 	cmp		[bp+MENU.wFirstVisibleItem], cx
@@ -190,5 +190,5 @@
 	ja		SHORT .ItemIsNotVisible
 	stc		; Item is visible
-ALIGN JUMP_ALIGN, ret
+ALIGN MENU_JUMP_ALIGN, ret
 .ItemIsNotVisible:
 	ret
@@ -204,5 +204,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_GetLastVisibleItemOnPageToAX:
 	xchg	cx, ax
@@ -223,5 +223,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_GetActualVisibleItemsOnPageToCX:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
@@ -229,5 +229,5 @@
 	jb		SHORT .Return
 	mov		cx, [bp+MENUINIT.wItems]
-ALIGN JUMP_ALIGN, ret
+ALIGN MENU_JUMP_ALIGN, ret
 .Return:
 	ret
@@ -243,5 +243,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuScrollbars_GetMaxVisibleItemsOnPageToCX:
 	eMOVZX	cx, [bp+MENUINIT.bHeight]
Index: trunk/Assembly_Library/Src/Menu/MenuText.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 369)
@@ -16,5 +16,5 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_ClearTitleArea:
 	CALL_DISPLAY_LIBRARY PushDisplayContext		; Save cursor coordinates
@@ -24,5 +24,5 @@
 %endif
 		
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_ClearInformationArea:
 	CALL_DISPLAY_LIBRARY PushDisplayContext		; Save cursor coordinates
@@ -50,5 +50,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_RefreshTitle:
 	cmp		BYTE [bp+MENUINIT.bTitleLines], 0
@@ -57,5 +57,5 @@
 	jmp		MenuEvent_RefreshTitle
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_RefreshInformation:
 	cmp		BYTE [bp+MENUINIT.bInfoLines], 0
@@ -74,5 +74,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PrepareToDrawTitleArea:
 	mov		si, ATTRIBUTE_CHARS.cTitle
@@ -80,5 +80,5 @@
 	jmp		SHORT FinishPreparationsToDrawTitleOrInformationArea
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_PrepareToDrawInformationArea:
 	mov		si, ATTRIBUTE_CHARS.cInformation
@@ -98,5 +98,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_RefreshAllItems:
 	push	cx
@@ -104,5 +104,5 @@
 	call	MenuScrollbars_GetActualVisibleItemsOnPageToCX
 	mov		ax, [bp+MENU.wFirstVisibleItem]
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .ItemRefreshLoop:
 	call	MenuText_RefreshItemFromAX
@@ -124,5 +124,5 @@
 ;		BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_RefreshItemFromAX:
 	push	cx
@@ -151,5 +151,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuText_AdjustDisplayContextForDrawingItemFromCX:
 	mov		ax, cx
@@ -171,5 +171,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 AdjustDisplayContextForDrawingTextsAtCoordsInAXwithAttrTypeInSIandCharOutFunctionInDX:
 	CALL_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
@@ -192,5 +192,5 @@
 ;		AX, BX, DX, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 ClearPreviousItem:
 	CALL_DISPLAY_LIBRARY GetSoftwareCoordinatesToAX
@@ -217,5 +217,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 GetItemTextAttributeTypeToSIforItemInCX:
 	mov		si, ATTRIBUTE_CHARS.cItem
@@ -226,5 +226,5 @@
 	jne		SHORT .ReturnAttributeTypeInSI
 	sub		si, BYTE ATTRIBUTE_CHARS.cItem - ATTRIBUTE_CHARS.cHighlightedItem
-ALIGN JUMP_ALIGN, ret
+ALIGN MENU_JUMP_ALIGN, ret
 .ReturnAttributeTypeInSI:
 	ret
@@ -241,5 +241,5 @@
 ;		AX, CX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 DrawScrollbarCharacterForItemInCXifNecessary:
 	call	MenuScrollbars_AreScrollbarsNeeded
@@ -247,5 +247,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .DrawScrollbarCharacter:
 	call	MenuBorders_AdjustDisplayContextForDrawingBorders
Index: trunk/Assembly_Library/Src/Menu/MenuTime.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuTime.asm	(revision 293)
+++ trunk/Assembly_Library/Src/Menu/MenuTime.asm	(revision 369)
@@ -15,5 +15,5 @@
 ;		AX, BX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuTime_StartSelectionTimeoutWithTicksInAX:
 	push	ds
@@ -34,5 +34,5 @@
 ;		AX, BX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuTime_StopSelectionTimeout:
 	test	BYTE [bp+MENU.bFlags], FLG_MENU_TIMEOUT_COUNTDOWN
@@ -52,5 +52,5 @@
 ;		AX, BX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuTime_UpdateSelectionTimeout:
 	test	BYTE [bp+MENU.bFlags], FLG_MENU_TIMEOUT_COUNTDOWN
@@ -66,5 +66,5 @@
 	ret
 
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 .RedrawSinceNoTimeout:
 	call	MenuBorders_RedrawBottomBorderLine
@@ -84,5 +84,5 @@
 ;		AX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 MenuTime_GetTimeoutSecondsLeftToAX:
 	push	ds
@@ -117,5 +117,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+ALIGN MENU_JUMP_ALIGN
 PointDSBXtoTimeoutCounter:
 	push	ss